<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX User Guide: vx_kernel.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
<h1>vx_kernel.h</h1><a href="vx__kernel_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * Copyright (c) 2012-2016 The Khronos Group Inc.</span>
<a name="l00003"></a>00003 <span class="comment"> *</span>
<a name="l00004"></a>00004 <span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a</span>
<a name="l00005"></a>00005 <span class="comment"> * copy of this software and/or associated documentation files (the</span>
<a name="l00006"></a>00006 <span class="comment"> * &quot;Materials&quot;), to deal in the Materials without restriction, including</span>
<a name="l00007"></a>00007 <span class="comment"> * without limitation the rights to use, copy, modify, merge, publish,</span>
<a name="l00008"></a>00008 <span class="comment"> * distribute, sublicense, and/or sell copies of the Materials, and to</span>
<a name="l00009"></a>00009 <span class="comment"> * permit persons to whom the Materials are furnished to do so, subject to</span>
<a name="l00010"></a>00010 <span class="comment"> * the following conditions:</span>
<a name="l00011"></a>00011 <span class="comment"> *</span>
<a name="l00012"></a>00012 <span class="comment"> * The above copyright notice and this permission notice shall be included</span>
<a name="l00013"></a>00013 <span class="comment"> * in all copies or substantial portions of the Materials.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * MODIFICATIONS TO THIS FILE MAY MEAN IT NO LONGER ACCURATELY REFLECTS</span>
<a name="l00016"></a>00016 <span class="comment"> * KHRONOS STANDARDS. THE UNMODIFIED, NORMATIVE VERSIONS OF KHRONOS</span>
<a name="l00017"></a>00017 <span class="comment"> * SPECIFICATIONS AND HEADER INFORMATION ARE LOCATED AT</span>
<a name="l00018"></a>00018 <span class="comment"> *    https://www.khronos.org/registry/</span>
<a name="l00019"></a>00019 <span class="comment"> *</span>
<a name="l00020"></a>00020 <span class="comment"> * THE MATERIALS ARE PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND,</span>
<a name="l00021"></a>00021 <span class="comment"> * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF</span>
<a name="l00022"></a>00022 <span class="comment"> * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.</span>
<a name="l00023"></a>00023 <span class="comment"> * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY</span>
<a name="l00024"></a>00024 <span class="comment"> * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,</span>
<a name="l00025"></a>00025 <span class="comment"> * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE</span>
<a name="l00026"></a>00026 <span class="comment"> * MATERIALS OR THE USE OR OTHER DEALINGS IN THE MATERIALS.</span>
<a name="l00027"></a>00027 <span class="comment"> */</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#ifndef VX_KERNEL_H_</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#define VX_KERNEL_H_</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#ifdef __cplusplus</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00037"></a>00037 <span class="preprocessor">#endif</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00046"></a><a class="code" href="vx__kernel_8h.html#aa020e2b6ed4b2b168bcfecb1f52eba86">00046</a> <span class="preprocessor">#define TIVX_MAX_TARGETS_PER_KERNEL     (8u)</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>
<a name="l00051"></a><a class="code" href="structtivx__signature__t.html">00051</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>_tivx_signature_t {
<a name="l00053"></a><a class="code" href="structtivx__signature__t.html#a80f6496e8b7f46f488dc76b3adcda079">00053</a>     <a class="code" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85" title="Sets the standard enumeration type size to be a fixed quantity.">vx_enum</a>        directions[<a class="code" href="group__group__tivx__obj__desc__cfg.html#ga4cc5e19e782439d7422fd08f47c17b09" title="Max parameters in a kernel.">TIVX_KERNEL_MAX_PARAMS</a>];
<a name="l00055"></a><a class="code" href="structtivx__signature__t.html#a4804fd57a0f029c43c7872aa64a35e4f">00055</a>     <a class="code" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85" title="Sets the standard enumeration type size to be a fixed quantity.">vx_enum</a>        types[<a class="code" href="group__group__tivx__obj__desc__cfg.html#ga4cc5e19e782439d7422fd08f47c17b09" title="Max parameters in a kernel.">TIVX_KERNEL_MAX_PARAMS</a>];
<a name="l00057"></a><a class="code" href="structtivx__signature__t.html#afd4cdb8c9db7bb5d7f7ff404dc4f9b34">00057</a>     <a class="code" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85" title="Sets the standard enumeration type size to be a fixed quantity.">vx_enum</a>        states[<a class="code" href="group__group__tivx__obj__desc__cfg.html#ga4cc5e19e782439d7422fd08f47c17b09" title="Max parameters in a kernel.">TIVX_KERNEL_MAX_PARAMS</a>];
<a name="l00059"></a><a class="code" href="structtivx__signature__t.html#a33289a39c86d7e237820c2fd50f6b140">00059</a>     <a class="code" href="vx__types_8h.html#a1ddb983b9696cafdb4256c0df757171c" title="A 32-bit unsigned value.">vx_uint32</a>      num_parameters;
<a name="l00060"></a>00060 } <a class="code" href="structtivx__signature__t.html" title="The internal representation of the attributes associated with a run-time parameter...">tivx_signature_t</a>;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00068"></a><a class="code" href="structtivx__kernel__t.html">00068</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>_vx_kernel
<a name="l00069"></a>00069 {
<a name="l00071"></a><a class="code" href="structtivx__kernel__t.html#acfbb4895979ef55b8dc09c572b7075c0">00071</a>     <a class="code" href="structtivx__reference__t.html" title="The most basic type in the OpenVX system. Any type that inherits from tivx_reference_t...">tivx_reference_t</a> base;
<a name="l00072"></a>00072 
<a name="l00074"></a><a class="code" href="structtivx__kernel__t.html#a6c336a924c851366d1dabb837c244a0d">00074</a>     <a class="code" href="vx__types_8h.html#a9ce3f44bccc95f52b9897df2b3620713" title="An 8 bit ASCII character.">vx_char</a>        name[VX_MAX_KERNEL_NAME];
<a name="l00076"></a><a class="code" href="structtivx__kernel__t.html#a3b71abe3f58c8f250c3f5f10cfd9a0f3">00076</a>     <a class="code" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85" title="Sets the standard enumeration type size to be a fixed quantity.">vx_enum</a>        enumeration;
<a name="l00078"></a><a class="code" href="structtivx__kernel__t.html#adc3850b72f095a20b051bda5d67716f3">00078</a>     <a class="code" href="structtivx__signature__t.html" title="The internal representation of the attributes associated with a run-time parameter...">tivx_signature_t</a> signature;
<a name="l00080"></a><a class="code" href="structtivx__kernel__t.html#ad6704409eeb206ff8698121f8c1ef34f">00080</a>     <a class="code" href="vx__types_8h.html#a69cfdc6762850b1afdffcdbebaab8eb9" title="The user-defined kernel node parameters validation function. The function only needs...">vx_kernel_validate_f</a>    validate;
<a name="l00082"></a><a class="code" href="structtivx__kernel__t.html#acb2f9143dfc6c1d30dd29f28f4ee9742">00082</a>     <a class="code" href="vx__types_8h.html#a512f8da4d07b02aa9827c5d6f1af0b26" title="The pointer to the kernel initializer. If the host code requires a call to initialize...">vx_kernel_initialize_f</a> initialize;
<a name="l00084"></a><a class="code" href="structtivx__kernel__t.html#aa9d3d74adaed638d933e5c181fcd0b09">00084</a>     <a class="code" href="vx__types_8h.html#a5e86f87af69c68e3066c4b745498048c" title="The pointer to the kernel deinitializer. If the host code requires a call to deinitialize...">vx_kernel_deinitialize_f</a> deinitialize;
<a name="l00086"></a><a class="code" href="structtivx__kernel__t.html#a2d0ab6b9ed267690cbd13d8a219c7d57">00086</a>     <a class="code" href="vx__types_8h.html#a970c28a9c06c23c8567229d50ab341dc" title="The pointer to the Host side kernel.">vx_kernel_f</a>             function;
<a name="l00088"></a><a class="code" href="structtivx__kernel__t.html#af8e9b75c7d975818143bc06c6897f778">00088</a>     <a class="code" href="vx__types_8h.html#a1ddb983b9696cafdb4256c0df757171c" title="A 32-bit unsigned value.">vx_uint32</a>               num_targets;
<a name="l00090"></a><a class="code" href="structtivx__kernel__t.html#a7c5a152bcb2070d29d63e36fc8c67de8">00090</a>     <span class="keywordtype">char</span>                    target_name[<a class="code" href="vx__kernel_8h.html#aa020e2b6ed4b2b168bcfecb1f52eba86" title="Maximum targets a kernel can run on.">TIVX_MAX_TARGETS_PER_KERNEL</a>][<a class="code" href="group__group__tivx__ext.html#ga0731c235cd560c819c84532ca108f8f2" title="Max possible name of a target.">TIVX_TARGET_MAX_NAME</a>];
<a name="l00092"></a><a class="code" href="structtivx__kernel__t.html#aa9c7555b6d372c72a6c3cdfac04ff6b5">00092</a>     <a class="code" href="vx__types_8h.html#a46d89d47ad9a2de1de723d0db861d324" title="A wrapper of size_t to keep the naming convention uniform.">vx_size</a>                 local_data_size;
<a name="l00094"></a><a class="code" href="structtivx__kernel__t.html#aae966b4e2d599a0af197c4dd117c1ba7">00094</a>     <a class="code" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0" title="A Boolean value. This allows 0 to be FALSE, as it is in C, and any non-zero to be...">vx_bool</a>                 is_target_kernel;
<a name="l00095"></a>00095 
<a name="l00099"></a><a class="code" href="structtivx__kernel__t.html#ab7dd06f256af6a728ac64620022e392f">00099</a>     <a class="code" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0" title="A Boolean value. This allows 0 to be FALSE, as it is in C, and any non-zero to be...">vx_bool</a>                 lock_kernel_remove;
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 } <a class="code" href="structtivx__kernel__t.html" title="Kernel object internal state.">tivx_kernel_t</a>;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00111"></a>00111 <a class="code" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85" title="Sets the standard enumeration type size to be a fixed quantity.">vx_enum</a> <a class="code" href="group__group__vx__kernel.html#gae4a8c1839a95c563eaf380bc1081027e" title="Get default target ID associated with this kernel.">ownKernelGetDefaultTarget</a>(<a class="code" href="vx__types_8h.html#a3a8a8757a8cc42cdd1af41e5b8bf127a" title="An opaque reference to the descriptor of a kernel.">vx_kernel</a> kernel);
<a name="l00112"></a>00112 
<a name="l00121"></a>00121 <a class="code" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85" title="Sets the standard enumeration type size to be a fixed quantity.">vx_enum</a> <a class="code" href="group__group__vx__kernel.html#ga61cbd0db4e18f3eafdb6510b4375b5c0" title="Match user provided target with supported targets and return target ID on which to...">ownKernelGetTarget</a>(<a class="code" href="vx__types_8h.html#a3a8a8757a8cc42cdd1af41e5b8bf127a" title="An opaque reference to the descriptor of a kernel.">vx_kernel</a> kernel, <span class="keyword">const</span> <span class="keywordtype">char</span> *target_string);
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 <span class="preprocessor">#ifdef __cplusplus</span>
<a name="l00125"></a>00125 <span class="preprocessor"></span>}
<a name="l00126"></a>00126 <span class="preprocessor">#endif</span>
<a name="l00127"></a>00127 <span class="preprocessor"></span>
<a name="l00128"></a>00128 <span class="preprocessor">#endif</span>
</pre></div></div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
